#include "pygii.h"
#include <ggi/internal/internal.h>
#include <ggi/ggi.h>

typedef struct GGIVisualObject_s GGIVisualObject;

typedef PyObject *(*ExtGetAttrFunc)(GGIVisualObject *, char *);
typedef int (*ExtSetAttrFunc)(GGIVisualObject *, char *, PyObject *);


typedef struct GGIExtension_s {
	char * name;
	ExtGetAttrFunc getattr;
	ExtSetAttrFunc setattr;
	struct GGIExtension_s * next;
} GGIExtension;

struct GGIVisualObject_s {
	PyObject_HEAD
	ggi_visual_t vis;
	ggi_mode mode;
	const ggi_pixelformat * pf;
	int                     nb_exts;
	struct GGIExtension_s * exts;
};

typedef struct {
	PyObject_HEAD
	ggi_mode mode;
} GGIModeObject;

typedef struct {
	PyObject_HEAD
	GGIVisualObject * vis;
	ggi_pixel       * pixels;
	int             length;
	int             alloc;
} GGIPackObject;

#ifndef PYGGI_MODULE
#define GGIVisual_Check(op) ((op)->ob_type == ggi_c_api->visual_type)
#define GGIMode_Check(op) ((op)->ob_type == ggi_c_api->mode_type)
#define GGIPack_Check(op) ((op)->ob_type == ggi_c_api->pack_type)
#else
#define GGIVisual_Check(op) ((op)->ob_type == &visual_type)
#define GGIMode_Check(op) ((op)->ob_type == &mode_type)
#define GGIPack_Check(op) ((op)->ob_type == &pack_type)
#endif

typedef struct {
	PyTypeObject * visual_type;
	PyTypeObject * mode_type;
	PyTypeObject * pack_type;
	int (*attach)(GGIVisualObject *, char *,  ExtGetAttrFunc ga, ExtSetAttrFunc sa);
	int (*detach)(GGIVisualObject *, char *);
} Pyggi_C_api;
